package br.jus.tjpb.selo.clientsample;

import java.io.ByteArrayInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

import javax.activation.DataHandler;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.datatype.DatatypeFactory;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.WebServiceFeature;
import javax.xml.ws.soap.MTOMFeature;
import javax.xml.ws.soap.SOAPBinding;

import org.apache.commons.lang.RandomStringUtils;

import br.jus.tjsc.selo.clientsample.stubs.Exception_Exception;
import br.jus.tjsc.selo.clientsample.stubs.SeloService;
import br.jus.tjsc.selo.clientsample.stubs.SeloService_Service;
import br.jus.tjsc.selo.xmlschema.ApontamentoProtesto;
import br.jus.tjsc.selo.xmlschema.Ato;
import br.jus.tjsc.selo.xmlschema.AtoSelado;
import br.jus.tjsc.selo.xmlschema.Atos;
import br.jus.tjsc.selo.xmlschema.AusenciaEmancipacaoMPresumidaInterdicao;
import br.jus.tjsc.selo.xmlschema.Autenticacao;
import br.jus.tjsc.selo.xmlschema.CasamentoHabilitacao;
import br.jus.tjsc.selo.xmlschema.ComunicacaoEscritura;
import br.jus.tjsc.selo.xmlschema.DistribuicaoTitulos;
import br.jus.tjsc.selo.xmlschema.Documento;
import br.jus.tjsc.selo.xmlschema.Endereco;
import br.jus.tjsc.selo.xmlschema.Imovel;
import br.jus.tjsc.selo.xmlschema.ImpostosTaxas;
import br.jus.tjsc.selo.xmlschema.MessageAtos;
import br.jus.tjsc.selo.xmlschema.MessageSelos;
import br.jus.tjsc.selo.xmlschema.NascimentoNatimortoObito;
import br.jus.tjsc.selo.xmlschema.NotasEscrituras;
import br.jus.tjsc.selo.xmlschema.NotasGenerico;
import br.jus.tjsc.selo.xmlschema.ObjectFactory;
import br.jus.tjsc.selo.xmlschema.ObjetoNegocio;
import br.jus.tjsc.selo.xmlschema.Pessoa;
import br.jus.tjsc.selo.xmlschema.PessoaResumo;
import br.jus.tjsc.selo.xmlschema.ProtestoGenerico;
import br.jus.tjsc.selo.xmlschema.Recibo;
import br.jus.tjsc.selo.xmlschema.ReconhecimentoFirma;
import br.jus.tjsc.selo.xmlschema.RegimeBens;
import br.jus.tjsc.selo.xmlschema.Registro;
import br.jus.tjsc.selo.xmlschema.RegistroImoveis;
import br.jus.tjsc.selo.xmlschema.RegistroTitulosDocPJ;
import br.jus.tjsc.selo.xmlschema.Selo;
import br.jus.tjsc.selo.xmlschema.SeloAto;
import br.jus.tjsc.selo.xmlschema.Sexo;
import br.jus.tjsc.selo.xmlschema.TipoPessoa;
import br.jus.tjsc.selo.xmlschema.TituloCredito;
import br.jus.tjsc.selo.xmlschema.UF;



public class ClientSample {
	
	public static final String XSD_CURRENTVERSION = "3.0";
	public static final String SCHEMA_PATH = "br.jus.tjsc.selo.xmlschema";

	public static void main(String[] args) throws Exception_Exception, DatatypeConfigurationException, JAXBException, IOException {
        
		System.out.println("***********************************************");
		System.out.println("***** Iniciando comunicação com o Serviço *****");
		
		JAXBContext jc = JAXBContext.newInstance(SCHEMA_PATH, ObjectFactory.class.getClassLoader());
		
        SeloService_Service service1 = new SeloService_Service();
        
        SeloService port1 = service1.getSeloServicePort();
        Map<String, Object> ctxt = ((BindingProvider)port1).getRequestContext();
        //Habilitando o HTTP chunking mode para trabalhar com streaming de grandes anexos.
        ctxt.put("com.sun.xml.ws.transport.http.client.streaming.chunk.size", 8192);
        
		/**
		 * Solicitando geração de selos
		 */
      
        String login,senha, NomeAto;
        Integer nuCNS =null;
        Integer wait = null;
        Scanner reader = new Scanner(System.in);
        System.out.println("Digite o login do Cartório: ");
        login = reader.next();
        System.out.println("Digite a senha do Cartório: ");
        senha = reader.next();
        System.out.println("Digite o CNS do Cartório: ");
        System.out.println("*digite qualquer coisa caso use um perfil tabeliao.");
        System.out.println("Caso use o perfil gerente é necessário informar o CNS válido do cartório que deseja testar.");
        nuCNS = reader.nextInt();
        System.out.println("Digite o nome do ato: ");
        NomeAto = reader.next();
	
        
        /**
         * Recuperando Selos
         * O retorno é um marshal jaxb em bytes de um objeto MensageSelos. Usa-se o unmarshal para recuperar o objeto.
         * O resultado importante é a lista de selos disponíveis para utilização.
        */
        System.out.println("## Solicitando Selos ##");
   
     
        byte[] documento = port1.fornecerSelos(login, senha, nuCNS);
        Unmarshaller um = jc.createUnmarshaller();
        InputStream is = new ByteArrayInputStream(documento);
        MessageSelos msgSelos = (MessageSelos) um.unmarshal(is);
        is.close();
        List<Selo> selos = msgSelos.getSelos().getSelo();
        System.out.println(" - Quantidade de selos recuperados: " + selos.size());
        
        /**
         * Enviando Atos
         */
        System.out.println("## Preparando Atos Selados ##");
        //Preparando objeto de transporte MessageAtos
        MessageAtos msgAtos = new MessageAtos();
        msgAtos.setMessageDate(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
        msgAtos.setMessageID(10);//tirar depois
        msgAtos.setCodigoServentia(10);
        msgAtos.setVersion(XSD_CURRENTVERSION);
        
        List<Ato> atosSelados = new ArrayList<Ato>();
        //Iterando os selos resgatados e preparando os atos selados para serem enviados
        for (int i = 0; i < selos.size(); i++) {
        	Ato ato = criarAtoProtestoGenerico(new BigDecimal(14), new BigDecimal(11), selos.get(i), "Coisinha de Jesus",10);
        	atosSelados.add(ato);
		}
        
    	Atos atos = new Atos();
        atos.setAto(atosSelados);
        msgAtos.setAtos(atos);
        
        //Gerando o marshal do objeto MenssageAtos para envio.
		Marshaller m = jc.createMarshaller();
		m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
		m.setProperty(Marshaller.JAXB_ENCODING, "ISO-8859-1");
		StringWriter sw = new StringWriter();
		m.marshal(msgAtos, sw);
		byte[] bytesMsgAtos = sw.toString().getBytes();
		//ativando o MTOM para envio de grandes anexos.
		BindingProvider bp = (BindingProvider) port1;
        SOAPBinding binding = (SOAPBinding) bp.getBinding();
        binding.setMTOMEnabled(true);
        
        System.out.println("## Enviando Atos Selados ##");
        
        byte[] recibo =  port1.enviarAtos(login, senha, new DataHandler(bytesMsgAtos, "application/octet-stream"));
		
	       
		System.out.println("- Atos selados processados com sucesso.");
			
		System.out.println("\n\n*********************************");
        System.out.println("Fim da execução!");
      
	}

	private static Ato criarAtoAutenticacao(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa) throws DatatypeConfigurationException {
		
		Integer idTipoAto = 6;
		
		ObjectFactory objFactory = new ObjectFactory();
		Ato ato = objFactory.createAutenticacao();
	    ato.setCodigoServentia(selo.getNuCartorio());
	    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
	    ato.setValorEmolumento(valorEmolumento);
	    ato.setValorAto(valorAto);
	    ato.setTipoAto(idTipoAto);
	    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
	    ato.setResponsavel(1);
	    
	    SeloAto seloAto = objFactory.createSeloAto();
	    seloAto.setNumeroSerie(selo.getNumeroSerie());
	    seloAto.setValidador(selo.getValidador());
	    seloAto.setTipoSelo(selo.getTipoSelo());
	    
	    ato.setRecibo(getRecibos());
	    ((AtoSelado)ato).setSelo(seloAto);
	    ((AtoSelado)ato).setRecolhimentos(getImpostos());
	    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
	    ((AtoSelado)ato).setRetificador(false);
	    ((Autenticacao)ato).setDescricaoDocto("Descrição do documento autenticado.");
	    ((Autenticacao)ato).setRessalva("Essa é a ressalva.");
	    
	    return ato;
	}
	
	private static Ato criarAtoNotasGenerico(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa) throws DatatypeConfigurationException {
		
		Integer idTipoAto = 9;
		
		ObjectFactory objFactory = new ObjectFactory();
		NotasGenerico ato = objFactory.createNotasGenerico();
	    ato.setCodigoServentia(selo.getNuCartorio());
	    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
	    ato.setValorEmolumento(valorEmolumento);
	    ato.setValorAto(valorAto);
	    ato.setTipoAto(idTipoAto);
	    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
	    ato.setResponsavel(1);
	    
	    SeloAto seloAto = objFactory.createSeloAto();
	    seloAto.setNumeroSerie(selo.getNumeroSerie());
	    seloAto.setValidador(selo.getValidador());
	    seloAto.setTipoSelo(selo.getTipoSelo());
	    
	    ato.setRecibo(getRecibos());
	    ((AtoSelado)ato).setSelo(seloAto);
	    ((AtoSelado)ato).setRecolhimentos(getImpostos());
	    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
	    ((AtoSelado)ato).setRetificador(false);
	    ((NotasGenerico)ato).setSubTipoAto(32);
	    ((NotasGenerico)ato).setValidadeAto("Até que vale.");
	    ((NotasGenerico)ato).setProtocolo("22545484");
	    ((NotasGenerico)ato).setPartes(getPartes("Fulano Parte de Algo"));
	    ((NotasGenerico)ato).setRegistro(getRegistro());
	    ((NotasGenerico)ato).setClausulaGeral("Essa é a cláusula geral.");
	    
	    return ato;
	}
	
	private static Ato criarAtoRegistroImoveis(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa) throws DatatypeConfigurationException {
		
		Integer idTipoAto = 11;
		
		ObjectFactory objFactory = new ObjectFactory();
		RegistroImoveis ato = objFactory.createRegistroImoveis();
	    ato.setCodigoServentia(selo.getNuCartorio());
	    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
	    ato.setValorEmolumento(valorEmolumento);
	    ato.setValorAto(valorAto);
	    ato.setTipoAto(idTipoAto);
	    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
	    ato.setResponsavel(1);
	    
	    SeloAto seloAto = objFactory.createSeloAto();
	    seloAto.setNumeroSerie(selo.getNumeroSerie());
	    seloAto.setValidador(selo.getValidador());
	    seloAto.setTipoSelo(selo.getTipoSelo());
	    
	    ato.setRecibo(getRecibos());
	    ((AtoSelado)ato).setSelo(seloAto);
	    ((AtoSelado)ato).setRecolhimentos(getImpostos());
	    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
	    ((AtoSelado)ato).setRetificador(false);
	    ((RegistroImoveis)ato).setSubTipoAto(61);
	    ((RegistroImoveis)ato).setValidadeAto("Até que vale.");
	    ((RegistroImoveis)ato).setMatricula("123456");
	    ((RegistroImoveis)ato).setPartes(getPartes("Fulano Parte de Algo"));
	    ((RegistroImoveis)ato).setImovel(getImoveis("Imóvel Sem Futuro"));
	    ((RegistroImoveis)ato).setRegistro(getRegistro());
	    ((RegistroImoveis)ato).setClausulaGeral("Essa é a cláusula geral.");
	    
	    return ato;
	}
	
	private static List<Pessoa> getPartes(String dsNomePessoa) {
		
		ObjectFactory objFactory = new ObjectFactory();
		
		Pessoa pessoa = objFactory.createPessoa();
	    pessoa.setNomePessoa(dsNomePessoa);
	    pessoa.setTipoPessoa(TipoPessoa.FÍSICA);
	    
	    Documento doc = objFactory.createDocumento();
	    doc.setNumero(RandomStringUtils.randomNumeric(7));
	    doc.setTipoDocumento(1);
	    List<Documento> docs = new ArrayList<Documento>();
	    docs.add(doc);
	    
	    pessoa.setDocumento(docs);
	    List<Pessoa> partes = new ArrayList<Pessoa>();
	    partes.add(pessoa);
	    
	    return partes;
	}
	
	private static List<Pessoa> getPartesNascimento(String dsNomePessoa) {
		
		ObjectFactory objFactory = new ObjectFactory();
		
		Pessoa pessoa = objFactory.createPessoa();
		Pessoa pessoapai = objFactory.createPessoa();
		Pessoa pessoamae = objFactory.createPessoa();
		
	    pessoa.setNomePessoa(dsNomePessoa);
	    pessoa.setTipoPessoa(TipoPessoa.FÍSICA);
	    
	    pessoapai.setNomePessoa(dsNomePessoa+"-Pai");
	    pessoapai.setTipoPessoa(TipoPessoa.FÍSICA);
	    
	    pessoamae.setNomePessoa(dsNomePessoa+"-Mae");
	    pessoamae.setTipoPessoa(TipoPessoa.FÍSICA);
	    
	    Documento doc = objFactory.createDocumento();
	    doc.setNumero(RandomStringUtils.randomNumeric(7));
	    doc.setTipoDocumento(1);
	    List<Documento> docs = new ArrayList<Documento>();
	    docs.add(doc);
	    
	    pessoa.setDocumento(docs);
	    pessoapai.setDocumento(docs);
	    pessoamae.setDocumento(docs);
	    List<Pessoa> partes = new ArrayList<Pessoa>();
	    partes.add(pessoa);
	    partes.add(pessoapai);
	    partes.add(pessoamae);

	
	    
	    return partes;
	}
	
	private static List<Imovel> getImoveis(String dsImovel) throws DatatypeConfigurationException {
		
		ObjectFactory objFactory = new ObjectFactory();
		
		Imovel imovel = objFactory.createImovel();
		imovel.setTipoImovel("Urbano");
	    imovel.setMatricula("0021554");
	    imovel.setEndereco(getEndereco());
	    
	    List<PessoaResumo> proprietarios = new ArrayList<PessoaResumo>();
	    proprietarios.add(getSolicitante("Proprietario de Algo"));
	    imovel.setProprietario(proprietarios);
	    
	    List<Imovel> imoveis = new ArrayList<Imovel>();
	    imoveis.add(imovel);
	    
	    return imoveis;
	}
	
	private static Registro getRegistro() {
		
		ObjectFactory objFactory = new ObjectFactory();
		
		Registro registro = objFactory.createRegistro();
	    registro.setCodigoLivro(122);
	    registro.setDataRegistroItem(new Date());
	    registro.setPaginaFinal("14");
	    registro.setPaginaInicial("12");
	    
	    return registro;
	}
	
	private static ObjetoNegocio getObjetoNegocio() throws DatatypeConfigurationException {
		
		ObjectFactory objFactory = new ObjectFactory();
		
		ObjetoNegocio obj = objFactory.createObjetoNegocio();
		
		obj.setCaracteristicas("Asim,... assado");
		obj.setDetalhesImovel(getImoveis("Minhacasa").get(0));
		obj.setEspecificacao("Isso,... aquilo");
		obj.setValorObjeto(new BigDecimal(100000));
		obj.setTipoObjeto("Casa");
	   
		
	    return obj;
	}
	
	private static TituloCredito getTitulo() throws DatatypeConfigurationException {
		
		ObjectFactory objFactory = new ObjectFactory();
		
		TituloCredito obj = objFactory.createTituloCredito();
		
		ArrayList<PessoaResumo> credor = new ArrayList<PessoaResumo>(), devedor = new ArrayList<PessoaResumo>();
		
		credor.add(getSolicitante("Maria de tal"));
		
		
		obj.setTipoTitulo(1);
		obj.setValorProtestado(new BigDecimal(10000));
		obj.setCredor(credor);
		obj.setDevedor(getPartes("Joao de tal").get(0));
		
	    return obj;
	}
	
	private static ApontamentoProtesto getApontamento() throws DatatypeConfigurationException {
		
		ObjectFactory objFactory = new ObjectFactory();
		
		ApontamentoProtesto obj = objFactory.createApontamentoProtesto();
		
		obj.setMotivoProtesto(1);
		obj.setApresentante(getSolicitante("Fulano de tal jr."));
		obj.setTituloCredito(getTitulo());
		
	    return obj;
	}
	

	
	private static PessoaResumo getSolicitante(String dsNomePessoa) throws DatatypeConfigurationException {
		
		ObjectFactory objFactory = new ObjectFactory();
		
		PessoaResumo pessoa = objFactory.createPessoaResumo();
	    pessoa.setNomePessoa(dsNomePessoa);
	    pessoa.setTipoPessoa(TipoPessoa.FÍSICA.value());
	    
	    Documento doc = objFactory.createDocumento();
	    doc.setNumero(RandomStringUtils.randomNumeric(7));
	    doc.setTipoDocumento(1);
	    List<Documento> docs = new ArrayList<Documento>();
	    docs.add(doc);
	    
	    pessoa.setDocumento(docs);
	    
	    return pessoa;
	}
	
	public static List<ImpostosTaxas> getImpostos() throws DatatypeConfigurationException {
		
		ObjectFactory objFactory = new ObjectFactory();
		ImpostosTaxas imposto1 = objFactory.createImpostosTaxas();
	    imposto1.setNomeImposto("FARPEN");
	    imposto1.setValorPago(new BigDecimal(RandomStringUtils.randomNumeric(2)));
	    ImpostosTaxas imposto2 = new ImpostosTaxas();
	    imposto2.setNomeImposto("FEPJ");
	    imposto2.setValorPago(new BigDecimal(RandomStringUtils.randomNumeric(2)));
	    List<ImpostosTaxas> impostos = new ArrayList<ImpostosTaxas>();
	    impostos.add(imposto1);
	    impostos.add(imposto2);
	    return impostos;
	}
	
	public static List<Recibo> getRecibos() throws DatatypeConfigurationException {
		ObjectFactory objFactory = new ObjectFactory();
		
		Recibo recibo = objFactory.createRecibo();
	    recibo.setDataRecibo(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
	    recibo.setNumeroRecibo(Integer.valueOf(RandomStringUtils.randomNumeric(5)));
	    recibo.setValorRecibo(new BigDecimal(RandomStringUtils.randomNumeric(2)));
	    List<Recibo> recibos = new ArrayList<Recibo>();
	    recibos.add(recibo);
	    return recibos;
	}
	
	public static Endereco getEndereco() {
		ObjectFactory objFactory = new ObjectFactory();
		
		Endereco end = objFactory.createEndereco();
		end.setBairro("Vale do Timbú");
	    end.setCidade(4964);
	    end.setDescricaoLogradouro("Rua Mito Fictícia");
	    end.setNumero("122");
	    end.setUf(UF.PB);
		
		return end;
	}
	
	
	//--------------------------  williams     
	
private static Ato criarAtoFirma(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa) throws DatatypeConfigurationException {
		
		Integer idTipoAto = 5;
		
		ObjectFactory objFactory = new ObjectFactory();
		Ato ato = objFactory.createReconhecimentoFirma();
	    ato.setCodigoServentia(selo.getNuCartorio());
	    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
	    ato.setValorEmolumento(valorEmolumento);
	    ato.setValorAto(valorAto);
	    ato.setTipoAto(idTipoAto);
	    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
	    ato.setResponsavel(1);
	    
	    SeloAto seloAto = objFactory.createSeloAto();
	    seloAto.setNumeroSerie(selo.getNumeroSerie());
	    seloAto.setValidador(selo.getValidador());
	    seloAto.setTipoSelo(selo.getTipoSelo());
	    
	    ato.setRecibo(getRecibos());
	    ((AtoSelado)ato).setSelo(seloAto);
	    ((AtoSelado)ato).setRecolhimentos(getImpostos());
	    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
	    ((AtoSelado)ato).setRetificador(false);
	    ((ReconhecimentoFirma)ato).setSignatario(getPartes(dsNomePessoa).get(0));
	    ((ReconhecimentoFirma)ato).setDescricaoDocto("Descrição do documento autenticado.");
	    ((ReconhecimentoFirma)ato).setTipoReconhecimento(81);
	    
	    return ato;
	}

private static Ato criarAtoNotasEscritura(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa) throws DatatypeConfigurationException {
	
	Integer idTipoAto = 2;
	
	ObjectFactory objFactory = new ObjectFactory();
	Ato ato = objFactory.createNotasEscrituras();
    ato.setCodigoServentia(selo.getNuCartorio());
    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
    ato.setValorEmolumento(valorEmolumento);
    ato.setValorAto(valorAto);
    ato.setTipoAto(idTipoAto);
    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
    ato.setResponsavel(1);
    
    SeloAto seloAto = objFactory.createSeloAto();
    seloAto.setNumeroSerie(selo.getNumeroSerie());
    seloAto.setValidador(selo.getValidador());
    seloAto.setTipoSelo(selo.getTipoSelo());
    
    ato.setRecibo(getRecibos());
    ((AtoSelado)ato).setSelo(seloAto);
    ((AtoSelado)ato).setRecolhimentos(getImpostos());
    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
    ((AtoSelado)ato).setRetificador(false);
    ((NotasEscrituras)ato).setPartes(getPartes(dsNomePessoa));
    ((NotasEscrituras)ato).setProtocolo("2589-p");
    ((NotasEscrituras)ato).setValidadeAto("Eterno");
    ((NotasEscrituras)ato).setRegistro(getRegistro());
    ((NotasEscrituras)ato).setObjetoNegocio(getObjetoNegocio());
    ((NotasEscrituras)ato).setSubTipoAto(31);
    
    
    return ato;
}

private static Ato criarAtoAusencia(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa) throws DatatypeConfigurationException {
	
	Integer idTipoAto = 20;
	
	ObjectFactory objFactory = new ObjectFactory();
	Ato ato = objFactory.createAusenciaEmancipacaoMPresumidaInterdicao();
    ato.setCodigoServentia(selo.getNuCartorio());
    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
    ato.setValorEmolumento(valorEmolumento);
    ato.setValorAto(valorAto);
    ato.setTipoAto(idTipoAto);
    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
    ato.setResponsavel(1);
    
    SeloAto seloAto = objFactory.createSeloAto();
    seloAto.setNumeroSerie(selo.getNumeroSerie());
    seloAto.setValidador(selo.getValidador());
    seloAto.setTipoSelo(selo.getTipoSelo());
    
    ato.setRecibo(getRecibos());
    ((AtoSelado)ato).setSelo(seloAto);
    ((AtoSelado)ato).setRecolhimentos(getImpostos());
    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
    ((AtoSelado)ato).setRetificador(false);
    ((AusenciaEmancipacaoMPresumidaInterdicao)ato).setPartes(getPartes(dsNomePessoa));
    ((AusenciaEmancipacaoMPresumidaInterdicao)ato).setProtocolo("98547-W");
    ((AusenciaEmancipacaoMPresumidaInterdicao)ato).setRegistro(getRegistro());
    ((AusenciaEmancipacaoMPresumidaInterdicao)ato).setClausulaGeral("Geral.... geral");
    ((AusenciaEmancipacaoMPresumidaInterdicao)ato).setSubTipoAto(94);
    
    
    return ato;
}

private static Ato criarAtoDistribuicao(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa) throws DatatypeConfigurationException {
	
	Integer idTipoAto = 20;
	
	ObjectFactory objFactory = new ObjectFactory();
	Ato ato = objFactory.createDistribuicaoTitulos();
    ato.setCodigoServentia(selo.getNuCartorio());
    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
    ato.setValorEmolumento(valorEmolumento);
    ato.setValorAto(valorAto);
    ato.setTipoAto(idTipoAto);
    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
    ato.setResponsavel(1);
    
    SeloAto seloAto = objFactory.createSeloAto();
    seloAto.setNumeroSerie(selo.getNumeroSerie());
    seloAto.setValidador(selo.getValidador());
    seloAto.setTipoSelo(selo.getTipoSelo());
    
    ato.setRecibo(getRecibos());
    ((AtoSelado)ato).setSelo(seloAto);
    ((AtoSelado)ato).setRecolhimentos(getImpostos());
    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
    ((AtoSelado)ato).setRetificador(false);    
    ((DistribuicaoTitulos)ato).setRegistro(getRegistro());
    ((DistribuicaoTitulos)ato).setApontamento(getApontamento());
    ((DistribuicaoTitulos)ato).setTabelionatoDistribuido("Tabelionato de juru");
    
    
    return ato;
}

private static Ato criarAtoCasamento(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa) throws DatatypeConfigurationException {
	
	Integer idTipoAto = 20;
	
	ObjectFactory objFactory = new ObjectFactory();
	Ato ato = objFactory.createCasamentoHabilitacao();
    ato.setCodigoServentia(selo.getNuCartorio());
    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
    ato.setValorEmolumento(valorEmolumento);
    ato.setValorAto(valorAto);
    ato.setTipoAto(idTipoAto);
    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
    ato.setResponsavel(1);
    
    SeloAto seloAto = objFactory.createSeloAto();
    seloAto.setNumeroSerie(selo.getNumeroSerie());
    seloAto.setValidador(selo.getValidador());
    seloAto.setTipoSelo(selo.getTipoSelo());
    
    ato.setRecibo(getRecibos());
    ((AtoSelado)ato).setSelo(seloAto);
    ((AtoSelado)ato).setRecolhimentos(getImpostos());
    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
    ((AtoSelado)ato).setRetificador(false);    
    ((CasamentoHabilitacao)ato).setRegistro(getRegistro());
    ((CasamentoHabilitacao)ato).setProtocolo("25698-g");
    ((CasamentoHabilitacao)ato).setPartes(getPartes("Jose de tal"));
    ((CasamentoHabilitacao)ato).setClausulaGeral("Clausula geral");
    ((CasamentoHabilitacao)ato).setRegimeBens(RegimeBens.COMUNHÃO_UNIVERSAL);
    ((CasamentoHabilitacao)ato).setSubTipoAto(91);
    
    
    return ato;
}


private static Ato criarAtoRegistroTitulo(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa) throws DatatypeConfigurationException {
	
	Integer idTipoAto = 20;
	
	ObjectFactory objFactory = new ObjectFactory();
	Ato ato = objFactory.createRegistroTitulosDocPJ();
    ato.setCodigoServentia(selo.getNuCartorio());
    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
    ato.setValorEmolumento(valorEmolumento);
    ato.setValorAto(valorAto);
    ato.setTipoAto(idTipoAto);
    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
    ato.setResponsavel(1);
    
    SeloAto seloAto = objFactory.createSeloAto();
    seloAto.setNumeroSerie(selo.getNumeroSerie());
    seloAto.setValidador(selo.getValidador());
    seloAto.setTipoSelo(selo.getTipoSelo());
    
    ato.setRecibo(getRecibos());
    ((AtoSelado)ato).setSelo(seloAto);
    ((AtoSelado)ato).setRecolhimentos(getImpostos());
    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
    ((AtoSelado)ato).setRetificador(false);    
    ((RegistroTitulosDocPJ)ato).setRegistro(getRegistro());
    ((RegistroTitulosDocPJ)ato).setProtocolo("5896-a");
    ((RegistroTitulosDocPJ)ato).setClausulaGeral("Clausula geral");
    ((RegistroTitulosDocPJ)ato).setSubTipoAto(71);
    ((RegistroTitulosDocPJ)ato).setValidadeAto("Eterno");    
    ((RegistroTitulosDocPJ)ato).setDocRegistrado("Sei naum....");
    ((RegistroTitulosDocPJ)ato).setPartes(getPartes("Fulanos e tais"));
    
    return ato;
}

private static Ato criarAtoComunicacao(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa) throws DatatypeConfigurationException {
	
	Integer idTipoAto = 20;
	
	ObjectFactory objFactory = new ObjectFactory();
	Ato ato = objFactory.createComunicacaoEscritura();
    ato.setCodigoServentia(selo.getNuCartorio());
    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
    ato.setValorEmolumento(valorEmolumento);
    ato.setValorAto(valorAto);
    ato.setTipoAto(idTipoAto);
    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
    ato.setResponsavel(1);
    
    SeloAto seloAto = objFactory.createSeloAto();
    seloAto.setNumeroSerie(selo.getNumeroSerie());
    seloAto.setValidador(selo.getValidador());
    seloAto.setTipoSelo(selo.getTipoSelo());
    
    ato.setRecibo(getRecibos());
    ((AtoSelado)ato).setSelo(seloAto);
    ((AtoSelado)ato).setRecolhimentos(getImpostos());
    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
    ((AtoSelado)ato).setRetificador(false);    
    ((ComunicacaoEscritura)ato).setRegistro(getRegistro());
    ((ComunicacaoEscritura)ato).setSeloEscritura("GHY7895");   
    
    
    return ato;
}


private static Ato criarAtoNascimento(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa) throws DatatypeConfigurationException {
	
	Integer idTipoAto = 20;
	
	ObjectFactory objFactory = new ObjectFactory();
	Ato ato = objFactory.createNascimentoNatimortoObito();
    ato.setCodigoServentia(selo.getNuCartorio());
    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
    ato.setValorEmolumento(valorEmolumento);
    ato.setValorAto(valorAto);
    ato.setTipoAto(idTipoAto);
    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
    ato.setResponsavel(1);
    
    SeloAto seloAto = objFactory.createSeloAto();
    seloAto.setNumeroSerie(selo.getNumeroSerie());
    seloAto.setValidador(selo.getValidador());
    seloAto.setTipoSelo(selo.getTipoSelo());
    
    ato.setRecibo(getRecibos());
    ((AtoSelado)ato).setSelo(seloAto);
    ((AtoSelado)ato).setRecolhimentos(getImpostos());
    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
    ((AtoSelado)ato).setRetificador(false);    
    ((NascimentoNatimortoObito)ato).setRegistro(getRegistro());
    ((NascimentoNatimortoObito)ato).setClausulaGeral("Nascimento");
    ((NascimentoNatimortoObito)ato).setLocal("Maternidade Frei Damiao");
    ((NascimentoNatimortoObito)ato).setNumeroDNVDO("24568956654");
    ((NascimentoNatimortoObito)ato).setSubTipoAto(98);
    ((NascimentoNatimortoObito)ato).setProtocolo("5497-q");
    ((NascimentoNatimortoObito)ato).setPartes(getPartesNascimento(dsNomePessoa));   
    ((NascimentoNatimortoObito)ato).setData("22 de junho de 1901");
    ((NascimentoNatimortoObito)ato).setSexo(Sexo.FEMININO);
    
    return ato;
}
	
private static Ato criarAtoProtestoGenerico(BigDecimal valorAto, BigDecimal valorEmolumento, Selo selo, String dsNomePessoa, int j) throws DatatypeConfigurationException {
	
	Integer idTipoAto = 20;
	
	ObjectFactory objFactory = new ObjectFactory();
	Ato ato = objFactory.createProtestoGenerico();
    //ato.setCodigoServentia(selo.getNuCartorio());
	 ato.setCodigoServentia(j);// tirar depois
    ato.setDataAto(DatatypeFactory.newInstance().newXMLGregorianCalendar((GregorianCalendar) GregorianCalendar.getInstance()));
    ato.setValorEmolumento(valorEmolumento);
    ato.setValorAto(valorAto);
    ato.setTipoAto(idTipoAto);
    ato.setIdAto(Integer.valueOf(RandomStringUtils.randomNumeric(4)));
    ato.setResponsavel(1);
    
    SeloAto seloAto = objFactory.createSeloAto();
    seloAto.setNumeroSerie(selo.getNumeroSerie());
    seloAto.setValidador(selo.getValidador());
    seloAto.setTipoSelo(selo.getTipoSelo());
    
    ato.setRecibo(getRecibos());
    ((AtoSelado)ato).setSelo(seloAto);
    ((AtoSelado)ato).setRecolhimentos(getImpostos());
    ((AtoSelado)ato).setSolicitante(getSolicitante(dsNomePessoa));
    ((AtoSelado)ato).setRetificador(false);
    ((ProtestoGenerico)ato).setSubTipoAto(51);
    ((ProtestoGenerico)ato).setValidadeAto("Eterno");
    ((ProtestoGenerico)ato).setProtocolo("699874-rt");
    ((ProtestoGenerico)ato).setPartes(getPartes(dsNomePessoa));
    ((ProtestoGenerico)ato).setRegistro(getRegistro());
    ((ProtestoGenerico)ato).setApontamento(getApontamento());
    ((ProtestoGenerico)ato).setRegistro(getRegistro());
    ((ProtestoGenerico)ato).setEncaminhadoPeloDistribuidor(true);
    
    return ato;
}
	
	
}
